"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.formattingDefaults = exports.schemaDefault = exports.modeConfigurationDefault = exports.MonacoGraphQLAPI = void 0;
var graphql_language_service_1 = require("graphql-language-service");
var monaco_editor_1 = require("monaco-editor");
var schemaCache = new Map();
var MonacoGraphQLAPI = (function () {
    function MonacoGraphQLAPI(_a) {
        var languageId = _a.languageId, schemaConfig = _a.schemaConfig, modeConfiguration = _a.modeConfiguration, formattingOptions = _a.formattingOptions;
        this._onDidChange = new monaco_editor_1.Emitter();
        this._onSchemaLoaded = new monaco_editor_1.Emitter();
        this._onSchemaConfigChange = new monaco_editor_1.Emitter();
        this._schemaCache = schemaCache;
        this._schemaConfig = {};
        this._documentString = null;
        this._externalFragmentDefinitions = null;
        this._langService = null;
        this._languageId = languageId;
        if (schemaConfig) {
            this.setSchemaConfig(schemaConfig);
        }
        this.setModeConfiguration(modeConfiguration);
        this.setFormattingOptions(formattingOptions);
        this._schemaCache = new Map();
    }
    Object.defineProperty(MonacoGraphQLAPI.prototype, "onDidChange", {
        get: function () {
            return this._onDidChange.event;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "onSchemaLoaded", {
        get: function () {
            return this._onSchemaLoaded.event;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "onSchemaConfigChange", {
        get: function () {
            return this._onSchemaConfigChange.event;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "parse", {
        get: function () {
            return this._langService.parse;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "langService", {
        get: function () {
            return this._langService;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "_currentSchemaId", {
        get: function () {
            return this.schemaConfig.uri || 'default';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "_currentSchemaEntry", {
        get: function () {
            var _a;
            return (_a = this._schemaCache.get(this._currentSchemaId)) !== null && _a !== void 0 ? _a : null;
        },
        enumerable: false,
        configurable: true
    });
    MonacoGraphQLAPI.prototype.getSchemaConfig = function () {
        var _a;
        return {
            schemaConfig: this.schemaConfig,
            exteralFragmentDefinitions: (_a = this.externalFragmentDefinitions) !== null && _a !== void 0 ? _a : undefined,
        };
    };
    MonacoGraphQLAPI.prototype.getVariablesJSONSchema = function (uri, documentText) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var JSONSchema;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, ((_a = this._langService) === null || _a === void 0 ? void 0 : _a.getVariablesJSONSchema(uri, documentText))];
                    case 1:
                        JSONSchema = _b.sent();
                        if (JSONSchema) {
                            return [2, JSONSchema];
                        }
                        return [2, null];
                }
            });
        });
    };
    MonacoGraphQLAPI.prototype.loadSchema = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ls, schema, schemaEntry, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        ls = new graphql_language_service_1.LanguageService(this.getSchemaConfig());
                        this._langService = ls;
                        return [4, ls.loadSchema()];
                    case 1:
                        schema = _a.sent();
                        if (schema) {
                            schemaEntry = {
                                schema: schema,
                                introspectionJSONString: ls.schemaConfig.introspectionJSONString,
                                documentString: ls.schemaConfig.documentString,
                            };
                            this.cacheSchema(schemaEntry);
                            this._onSchemaLoaded.fire(this);
                            return [2, schemaEntry];
                        }
                        return [3, 3];
                    case 2:
                        err_1 = _a.sent();
                        console.error('error fetching schema\n', err_1);
                        return [3, 3];
                    case 3: return [2, null];
                }
            });
        });
    };
    MonacoGraphQLAPI.prototype.cacheSchema = function (_a) {
        var introspectionJSONString = _a.introspectionJSONString, documentString = _a.documentString, schema = _a.schema;
        this._schemaCache.set(this._currentSchemaId, {
            introspectionJSONString: introspectionJSONString,
            schema: schema,
            documentString: documentString,
        });
    };
    Object.defineProperty(MonacoGraphQLAPI.prototype, "schemaReset", {
        get: function () {
            return {
                schema: undefined,
                introspectionJSON: undefined,
                introspectionJSONString: undefined,
                documentAST: undefined,
                documentString: undefined,
            };
        },
        enumerable: false,
        configurable: true
    });
    MonacoGraphQLAPI.prototype.getSchema = function () {
        return __awaiter(this, void 0, void 0, function () {
            var cachedSchema;
            return __generator(this, function (_a) {
                cachedSchema = this._currentSchemaEntry;
                if (cachedSchema) {
                    return [2, cachedSchema];
                }
                return [2, this.loadSchema()];
            });
        });
    };
    MonacoGraphQLAPI.prototype.changeSchema = function () {
        var cachedSchema = this._schemaCache.get(this.schemaConfig.uri || 'default');
        if (cachedSchema) {
            var ls = new graphql_language_service_1.LanguageService(this.getSchemaConfig());
            this._langService = ls;
            this._onSchemaLoaded.fire(this);
        }
        else {
            this.loadSchema().then();
        }
    };
    MonacoGraphQLAPI.prototype.reloadSchema = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.loadSchema()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(MonacoGraphQLAPI.prototype, "languageId", {
        get: function () {
            return this._languageId;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "modeConfiguration", {
        get: function () {
            return this._modeConfiguration;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "schemaConfig", {
        get: function () {
            return this._schemaConfig;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "formattingOptions", {
        get: function () {
            return this._formattingOptions;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "externalFragmentDefinitions", {
        get: function () {
            return this._externalFragmentDefinitions;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MonacoGraphQLAPI.prototype, "hasSchema", {
        get: function () {
            return Boolean(this._documentString);
        },
        enumerable: false,
        configurable: true
    });
    MonacoGraphQLAPI.prototype.setSchemaConfig = function (options) {
        this._schemaConfig = options || Object.create(null);
        this._onSchemaConfigChange.fire(this);
    };
    MonacoGraphQLAPI.prototype.updateSchemaConfig = function (options) {
        var _a, _b;
        this.setSchemaConfig(__assign(__assign(__assign({}, this._schemaConfig), options), { requestOpts: __assign(__assign(__assign({}, this._schemaConfig.requestOpts), options.requestOpts), { headers: __assign(__assign({}, (_a = this._schemaConfig.requestOpts) === null || _a === void 0 ? void 0 : _a.headers), (_b = options.requestOpts) === null || _b === void 0 ? void 0 : _b.headers) }) }));
    };
    MonacoGraphQLAPI.prototype.setSchemaUri = function (schemaUri) {
        this.setSchemaConfig(__assign(__assign(__assign({}, this._schemaConfig), { uri: schemaUri }), this.schemaReset));
    };
    MonacoGraphQLAPI.prototype.setSchema = function (schema) {
        this._schemaConfig = {
            schema: schema,
            buildSchemaOptions: this._schemaConfig.buildSchemaOptions,
        };
        this._onSchemaLoaded.fire(this);
    };
    MonacoGraphQLAPI.prototype.setExternalFragmentDefinitions = function (externalFragmentDefinitions) {
        this._externalFragmentDefinitions = externalFragmentDefinitions;
    };
    MonacoGraphQLAPI.prototype.setModeConfiguration = function (modeConfiguration) {
        this._modeConfiguration = modeConfiguration || Object.create(null);
        this._onDidChange.fire(this);
    };
    MonacoGraphQLAPI.prototype.setFormattingOptions = function (formattingOptions) {
        this._formattingOptions = formattingOptions || Object.create(null);
        this._onDidChange.fire(this);
    };
    return MonacoGraphQLAPI;
}());
exports.MonacoGraphQLAPI = MonacoGraphQLAPI;
exports.modeConfigurationDefault = {
    documentFormattingEdits: true,
    documentRangeFormattingEdits: false,
    completionItems: true,
    hovers: true,
    documentSymbols: false,
    tokens: false,
    colors: false,
    foldingRanges: false,
    diagnostics: true,
    selectionRanges: false,
};
exports.schemaDefault = {
    loadSchemaOnInit: true,
    loadSchemaOnChange: true,
    requestOpts: {
        headers: {
            'Content-Type': 'application/json',
        },
    },
    buildSchemaOptions: {
        assumeValidSDL: true,
    },
};
exports.formattingDefaults = {
    prettierConfig: {
        tabWidth: 2,
    },
};
//# sourceMappingURL=api.js.map